from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Int, Float, Boolean

Plot_Window_Differences_V0_1_0 = CommandToolBuilder(tool="plot_window_differences", base_command=["plot_window_differences"], inputs=[ToolInput(tag="in_before", input_type=File(optional=True), prefix="--before", doc=InputDocumentation(doc="Full path to dataframe 1 (will be treated) as 'before'")), ToolInput(tag="in_chrom", input_type=String(optional=True), prefix="--chrom", doc=InputDocumentation(doc="Chromosome to analyze. Must match name in dataframes.")), ToolInput(tag="in_sample_id", input_type=String(optional=True), prefix="--sample_id", doc=InputDocumentation(doc="Sample ID or other identifier to be used in naming")), ToolInput(tag="in_output_prefix", input_type=File(optional=True), prefix="--output_prefix", doc=InputDocumentation(doc="Full path to and prefix of desired output plot")), ToolInput(tag="in_marker_size", input_type=Int(optional=True), prefix="--marker_size", doc=InputDocumentation(doc="Marker size in matplotlib. Default is 10.")), ToolInput(tag="in_marker_transparency", input_type=Float(optional=True), prefix="--marker_transparency", doc=InputDocumentation(doc="Transparency of markers. Alpha in matplotlib. Default\nis 0.5")), ToolInput(tag="in_coordinate_scale", input_type=Int(optional=True), prefix="--coordinate_scale", doc=InputDocumentation(doc="Divide all coordinates by this value.Default is\n1000000, which will plot everything in megabases.")), ToolInput(tag="in_y_min", input_type=Float(optional=True), prefix="--y_min", doc=InputDocumentation(doc="If 'auto', will allow matplotlib to automatically\ndetermine limit. Otherwise, will set the y axis\nminimum to the value provided (int or float)")), ToolInput(tag="in_y_max", input_type=Float(optional=True), prefix="--y_max", doc=InputDocumentation(doc="If 'auto', will allow matplotlib to automatically\ndetermine limit. Otherwise, will set the y axis\nmaximum to the value provided (int or float)")), ToolInput(tag="in_x_limit", input_type=Int(optional=True), prefix="--x_limit", doc=InputDocumentation(doc="Max value on x axis. We recommend you use the\nchromosome length.")), ToolInput(tag="in_log_transform_depth", input_type=Boolean(optional=True), prefix="--log_transform_depth", doc=InputDocumentation(doc="Include flag to plot the absolute value of the log of\nthe depth difference *IN THE DIRECTION OF THE\nDIFFERENCE*. For exampe, if the difference is 2, this\nwould plot that value as abs(log10(2)), while if the\ndifference is -2, this would plot that value as\n-abs(log10(2)). This allows the sign of the difference\nto remain intact, while controlling for taking the log\nof negative numbers or values between 0 and 1.\n")), ToolInput(tag="in_after", input_type=String(optional=True), prefix="--after", doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output_prefix", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_prefix", type_hint=File()), doc=OutputDocumentation(doc="Full path to and prefix of desired output plot"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Plot_Window_Differences_V0_1_0().translate("wdl", allow_empty_container=True)

